﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;

namespace SGLF.Core.Helpers
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Extensions & Helpers
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    /// <summary>
    ///
    /// </summary>
    internal static class EnumHelper
    {
        // ==================================================================================================
        // Static Methods
        // ==================================================================================================

        /// <summary>
        /// Creates the enum dictionary.
        /// </summary>
        /// <typeparam name="TK">The type of the backup.</typeparam>
        /// <typeparam name="TV">The type of the average.</typeparam>
        /// <param name="defaultValue">The default value.</param>
        /// <returns></returns>
        /// <exception cref="System.ArgumentException">TK must be an enumerated type</exception>
        public static Dictionary<TK, TV> CreateDictionary<TK, TV>(TV defaultValue = default(TV))
            where TK : struct
            where TV : class
        {
            if (!typeof(TK).IsEnum)
                throw new ArgumentException("TK must be an enumerated type");

            Dictionary<TK, TV> dict = new Dictionary<TK, TV>();

            foreach (TK k in Enum.GetValues(typeof(TK)))
                dict[k] = defaultValue;

            return dict;
        }
    }
}