﻿using System;
using OpenTK;

namespace SGLF.Core.Helpers
{
    public static class StringHelper
    {
        public static bool ConvertHexFloats(string input, ref float[] output)
        {
            try
            {
                string[] splits = input.Split(' ');

                if (splits.Length == 0)
                    return false;

                output = new float[splits.Length];
                for (int i = 0; i < splits.Length; i++)
                {
                    long valLong = Convert.ToInt32(splits[i], 16);
                    byte[] valBytes = BitConverter.GetBytes(valLong);
                    output[i] = BitConverter.ToSingle(valBytes, 0);
                }

                return true;
            }
            catch
            {
                output = null;
                return false;
            }
        }

        public static bool ConvertHexFloats(string input, ref Vector3 vector)
        {
            float[] values = null;

            if (ConvertHexFloats(input, ref values) && (values.Length >= 3))
            {
                vector.X = values[0];
                vector.Y = values[1];
                vector.Z = values[2];
                return true;
            }

            return false;
        }

        public static bool ConvertHexFloats(string input, ref Vector2 vector)
        {
            float[] values = null;

            if (ConvertHexFloats(input, ref values) && (values.Length >= 2))
            {
                vector.X = values[0];
                vector.Y = values[1];
                return true;
            }

            return false;
        }
    }
}