﻿using System;
using System.Xml.Linq;
using OpenTK;
using SGLF.Core.Extensions;

namespace SGLF.Core.Helpers
{
    public static class XmlHelper
    {
        public static Vector2 GetVector2(XElement element, string x = "x", string y = "y")
        {
            return new Vector2(
                element.Attribute(x).Value<float>(0),
                element.Attribute(y).Value<float>(0)
            );
        }

        public static Vector3 GetVector3(XElement element, string x = "x", string y = "y", string z = "z")
        {
            return new Vector3(
                element.Attribute(x).Value<float>(0),
                element.Attribute(y).Value<float>(0),
                element.Attribute(z).Value<float>(0)
            );
        }

        public static Vector4 GetVector4(XElement element, string x = "x", string y = "y", string z = "z",
                                         string w = "w")
        {
            return new Vector4(
                element.Attribute(x).Value<float>(0),
                element.Attribute(y).Value<float>(0),
                element.Attribute(z).Value<float>(0),
                element.Attribute(w).Value<float>(0)
            );
        }

        public static Vector4 GetColor(XElement element)
        {
            string[] splits = element.Attribute("value").Value().Split(' ');

            return new Vector4(
                Single.Parse(splits[0]),
                Single.Parse(splits[1]),
                Single.Parse(splits[2]),
                (splits.Length == 4) ? Single.Parse(splits[3]) : 1.0f
            );
        }
    }
}