﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using OpenTK;

namespace SGLF.Core.Maths
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public struct BoundingSphere
    {
        // ==================================================================================================
        // Members
        // ==================================================================================================

        public Vector3 Position;
        public float Radius;

        // ==================================================================================================
        // Constructor
        // ==================================================================================================

        public BoundingSphere(Vector3 position, float radius)
        {
            Position = position;
            Radius = radius;
        }

        // ==================================================================================================
        // Methods
        // ==================================================================================================

        public bool TestPoint(Vector3 point)
        {
            return (point - Position).LengthSquared < (Radius * Radius);
        }

        public bool TestIntersection(BoundingSphere other)
        {
            return (other.Position - Position).Length < (Radius + other.Radius);
        }
    }
}