﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using OpenTK;

namespace SGLF.Graphics.Cameras
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public class OrthographicCamera : Camera
    {
        // ==================================================================================================
        // Properties
        // ==================================================================================================

        public float OrthoSize
        {
            get;
            set;
        }

        // ==================================================================================================
        // Constructor
        // ==================================================================================================

        public OrthographicCamera(float orthoSize = 1.0f, float nearClipPlane = 0.1f, float farClipPlane = 100.0f,
                                  float viewportX = 0.0f, float viewportY = 0.0f, float viewportW = 1.0f,
                                  float viewportH = 1.0f)
            : base(nearClipPlane, farClipPlane, new Vector2(viewportX, viewportY),
                   new Vector2(viewportW, viewportH))
        {
            OrthoSize = orthoSize;
        }

        // ==================================================================================================
        // Methods
        // ==================================================================================================

        public override Matrix4 GetProjectionMatrix(float aspectRatio)
        {
            return Matrix4.CreateOrthographic(OrthoSize * aspectRatio, OrthoSize, NearClipPlane, FarClipPlane);
        }
    }
}