﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using OpenTK;

namespace SGLF.Graphics.Cameras
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public class PerspectiveCamera : Camera
    {
        // ==================================================================================================
        // Properties
        // ==================================================================================================

        public float FieldOfView
        {
            get;
            set;
        }

        // ==================================================================================================
        // Constructor
        // ==================================================================================================

        public PerspectiveCamera(float fov = 60.0f, float nearClipPlane = 0.1f, float farClipPlane = 100.0f,
                                 float viewportX = 0.0f, float viewportY = 0.0f, float viewportW = 1.0f,
                                 float viewportH = 1.0f)
            : base(nearClipPlane, farClipPlane, new Vector2(viewportX, viewportY),
                   new Vector2(viewportW, viewportH))
        {
            FieldOfView = fov;
        }

        // ==================================================================================================
        // Methods
        // ==================================================================================================

        public override Matrix4 GetProjectionMatrix(float aspectRatio)
        {
            return Matrix4.CreatePerspectiveFieldOfView(MathHelper.DegreesToRadians(FieldOfView),
                                                        aspectRatio, NearClipPlane, FarClipPlane);
        }
    }
}