﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using SGLF.Core.Maths;
using SGLF.Graphics.Models;

namespace SGLF.Graphics
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public class Entity
    {
        // ==================================================================================================
        // Properties
        // ==================================================================================================

        public string Name
        {
            get;
            set;
        }

        public Transform Transform
        {
            get;
            private set;
        }

        public BoundingSphere BoundingSphere
        {
            get
            {
                return new BoundingSphere(Transform.Position, Model.BoundingRadius);
            }
        }

        public Model Model
        {
            get;
            set;
        }

        // ==================================================================================================
        // Constructor
        // ==================================================================================================

        public Entity(string name, Model model = null)
        {
            Name = name;
            Transform = new Transform();
            Model = model;
        }
    }
}