﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using OpenTK;
using SGLF.Core.Maths;

namespace SGLF.Graphics.Lights
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public class Light
    {
        // ==================================================================================================
        // Properties
        // ==================================================================================================

        public int LightType
        {
            get;
            set;
        }

        public Transform Transform
        {
            get;
            private set;
        }

        public Vector3 Irradiance
        {
            get;
            set;
        }

        public float Radius
        {
            get;
            set;
        }

        public Vector3 Parameters
        {
            get;
            set;
        }

        public BoundingSphere BoundingSphere
        {
            get
            {
                return new BoundingSphere(Transform.Position, 2 * Radius);
            }
        }

        // ==================================================================================================
        // Constructor / Disposer
        // ==================================================================================================

        public Light()
        {
            Transform = new Transform();
        }
    }
}