﻿using System;
using System.Drawing;
using OpenTK.Graphics.OpenGL;
using SGLF.Core.Resources;
using SGLF.Graphics.Textures;

namespace SGLF.Graphics.Managers
{
    public class TextureManager : ResourceManager<TextureObject>
    {
        protected override TextureObject LoadFromFile(string fileName)
        {
            switch (FindTextureType(fileName))
            {
                case TextureTarget.Texture1D:
                    return LoadTexture1D(fileName);

                case TextureTarget.Texture2D:
                    return LoadTexture2D(fileName);

                case TextureTarget.Texture3D:
                    return LoadTexture3D(fileName);

                case TextureTarget.TextureCubeMap:
                    return LoadTextureCube(fileName);

                default:
                    throw new InvalidOperationException();
            }
        }

        private TextureObject LoadTexture1D(string fileName)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Loads the texture2 command.
        /// </summary>
        /// <param name="fileName">Name of the file.</param>
        /// <returns></returns>
        private Texture2D LoadTexture2D(string fileName)
        {
            Bitmap bitmap = new Bitmap(fileName);

            Texture2D texture = new Texture2D(bitmap.Width, bitmap.Height, InternalFormat.Rgba8, 0);
            texture.SetImage(bitmap);
            texture.GenerateMipmaps();
            texture.MinFilter = TextureMinFilter.LinearMipmapLinear;

            return texture;
        }

        private TextureObject LoadTexture3D(string fileName)
        {
            throw new NotImplementedException();
        }

        private TextureObject LoadTextureCube(string fileName)
        {
            throw new NotImplementedException();
        }

        private TextureTarget FindTextureType(string fileName)
        {
            return TextureTarget.Texture2D;
        }
    }
}