﻿using System.Collections.Generic;
using System.Linq;
using SGLF.Graphics.Materials;

namespace SGLF.Graphics.Models
{
    public class Model : GraphicsResource
    {
        public List<Material> Materials
        {
            get;
            private set;
        }

        public List<Mesh> Meshes
        {
            get;
            private set;
        }

        public float BoundingRadius
        {
            get
            {
                return Meshes.Select(m => m.BoundingRadius).Max();
            }
        }

        public Model()
        {
            Meshes = new List<Mesh>();
            Materials = new List<Material>();
        }
    }
}