﻿using OpenTK.Graphics.OpenGL;

namespace SGLF.Graphics.Shaders
{
    public class Shader : GraphicsNamedResource
    {
        public ShaderType Type
        {
            get;
            private set;
        }

        public bool IsCompiled
        {
            get
            {
                int isCompiled;
                GL.GetShader(Handle, ShaderParameter.CompileStatus, out isCompiled);
                return (isCompiled == 1);
            }
        }

        public string InfoLog
        {
            get
            {
                return GL.GetShaderInfoLog(Handle);
            }
        }

        public Shader(ShaderType type, string sourceCode)
        {
            Type = type;

            Handle = GL.CreateShader(Type);
            GL.ShaderSource(Handle, sourceCode);
            GL.CompileShader(Handle);
        }

        protected override void Dispose(bool disposeManaged, bool disposeUnmanaged)
        {
            if (disposeUnmanaged)
                GL.DeleteShader(Handle);

            base.Dispose(disposeManaged, disposeUnmanaged);
        }
    }
}