﻿/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using System;
using System.Runtime.InteropServices;
using OpenTK;
using OpenTK.Graphics.OpenGL;

namespace SGLF.Graphics.Vertices
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public struct VertexPU : IVertex
    {
        // ==================================================================================================
        // Static Members
        // ==================================================================================================

        private static readonly VertexFormat format;

        // ==================================================================================================
        // Members
        // ==================================================================================================

        public Vector3 position;
        public Vector2 texCoords;

        // ==================================================================================================
        // Properties
        // ==================================================================================================

        public VertexFormat Format
        {
            get
            {
                return format;
            }
        }

        public Vector3 Position
        {
            get
            {
                return position;
            }
            set
            {
                position = value;
            }
        }

        public Vector3 Normal
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public Vector4 Tangent
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public Vector2 TexCoords
        {
            get
            {
                return texCoords;
            }
            set
            {
                texCoords = value;
            }
        }

        public Vector4 Color
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }

        public VertexPU(Vector3 position, Vector2 texCoords)
        {
            this.position = position;
            this.texCoords = texCoords;
        }

        static VertexPU()
        {
            Type type = typeof(VertexPU);
            int stride = Marshal.SizeOf(type);

            format = new VertexFormat(type,

                new VertexAttribute(0, VertexSemantics.Position, typeof(Vector3), 3,
                                    VertexAttribPointerType.Float, false,
                                    (int) Marshal.OffsetOf(type, "position"), stride),

                new VertexAttribute(3, VertexSemantics.TexCoord, typeof(Vector2), 2,
                                    VertexAttribPointerType.Float, false,
                                    (int) Marshal.OffsetOf(type, "texCoords"), stride)
            );
        }
    }
}