#version 420

// ----------------------------------------------------------------------------
// Includes
// ----------------------------------------------------------------------------

#include <Common.inc>

// ----------------------------------------------------------------------------
// Attributes
// ----------------------------------------------------------------------------

layout(location = 0) in vec3 aPosition;
layout(location = 1) in vec3 aNormal;
layout(location = 2) in vec4 aTangent;
layout(location = 3) in vec2 aTexCoord;
layout(location = 4) in vec4 aColor;

out vec3 vPosition;
out vec3 vNormal;
#ifdef SHADER_NORMAL_MAP
out vec3 vTangent;
out vec3 vBitangent;
#endif
#if defined(SHADER_DIFFUSE_MAP) || defined(SHADER_NORMAL_MAP)
out vec2 vTexCoord;
#endif

// ----------------------------------------------------------------------------
// Functions
// ----------------------------------------------------------------------------

void main()
{
    gl_Position = uScene.ModelViewProj * vec4(aPosition, 1.0);
    vPosition = (uScene.ModelView * vec4(aPosition, 1.0)).xyz;
    vNormal = uScene.Normal * aNormal;
    
    #ifdef SHADER_NORMAL_MAP
    vTangent = uScene.Normal * aTangent.xyz;
    vBitangent = cross(vNormal, vTangent) * aTangent.w;
    #endif
    
    #if defined(SHADER_DIFFUSE_MAP) || defined(SHADER_NORMAL_MAP)
    vTexCoord = aTexCoord;
    #endif
}