#version 420

// ----------------------------------------------------------------------------
// Includes
// ----------------------------------------------------------------------------

#include <Common.inc>

// ----------------------------------------------------------------------------
// Attributes
// ----------------------------------------------------------------------------

in vec3 vPosition;
in vec2 vTexCoord;

out vec4 fFragColor;

// ----------------------------------------------------------------------------
// Uniforms
// ----------------------------------------------------------------------------

layout(binding = 0) uniform sampler2D uColorMap;

// ----------------------------------------------------------------------------
// Functions
// ----------------------------------------------------------------------------

void main()
{
	vec4 color = texture(uColorMap, vTexCoord);

	fFragColor.rgb = LinearToGamma(color.rgb);
	fFragColor.a   = color.a;
}
